/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.16
        Device            :  dsPIC33EP256MC502
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC16 1.26
        MPLAB             :  MPLAB X 3.20
 */

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
 */
#include <stdlib.h>
#include <stdbool.h>
#include <xc.h>

#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/pin_manager.h"
#include <spi.h>

#define FPWM 125 //kHz
#define FOSC 40000//kHz

/*
 Prototype Functions
 */

volatile int ADC_FLAG =0;
volatile uint16_t HighSideV, LowSideV, HighSideC, LowSideC;

void DTC(int DUTY) {
   long int PWM_D;

    PWM_D = (FOSC*DUTY / (FPWM * 64));

    PDC1 = PWM_D;


}

void PWM_Period(void){
    int PERIOD;
    
    PERIOD = (FOSC/(FPWM*64));
    
    PTPER = PERIOD;
    
}

int Dead_Time(int DDT){
    
    int DTIME = FOSC*DDT/64;
    
    return DTIME;
}

void PWM_INIT(void) {
    
/*Complementary PWM Mode ? Independent Duty Cycle and Phase, Fixed Primary Period,
Edge-Aligned*/    

/* Set PWM Period on Primary Time Base */
PTPER = 2000;
//PWM_Period();
/* Set Phase Shift */
PHASE1 = 0;
/* Set Duty Cycles */
PDC1 = 0;

/* Set Dead Time Values */
DTR1 = DTR2 = DTR3 = 5;
ALTDTR1 = ALTDTR2 = ALTDTR3 = 5;
/* Set PWM Mode to Complementary */
IOCON1 = IOCON2 = IOCON3 = 0xC000;
/* Set Primary Time Base, Edge-Aligned Mode and Independent Duty Cycles */
PWMCON1 = PWMCON2 = PWMCON3 = 0x0000;
/* Configure Faults */
FCLCON1 = FCLCON2 = FCLCON3 = 0x0003;
/* 1:1 Prescaler */
PTCON2bits.PCLKDIV = 110;
/* Enable PWM Module */
//PTCON = 0x8000;

PMD1bits.PWMMD = 0;
PMD6bits.PWM1MD = 0;
PMD6bits.PWM2MD = 1;
PMD6bits.PWM3MD = 1;                                                                         ;
//PTCONbits.PTEN = 1;




}


/*
 Turns on all the LEDS at start up 
 */

void LED_All(void) {
    Charge_Toggle();
    Discharge_Toggle();
    Fault_Toggle();
    Comms_Toggle();

}

void Fault(void) {
    Fault_SetHigh();
    DTC(0);
}

/*
 Reads in voltages
 */



/*
                         Main application
 */
void main(void) {
    // initialize the device


    //PIND_SetDigitalInput();
    //PINC_SetDigitalInput();

    PMD1bits.I2C1MD = 1;
    //PMD1bits.SPI1MD = 1;
    PMD3bits.I2C2MD = 1;
    
    
    SYSTEM_Initialize();
    PWM_INIT();
    TMR1_Start();
    int MY_BUFFER_SIZE = 2;
    uint16_t    myWriteBuffer[MY_BUFFER_SIZE];
    uint16_t    myReadBuffer[MY_BUFFER_SIZE];
    uint16_t    writeData = 0b0110100000000000;
    uint16_t    readData;
    uint16_t    garbage;
    SPI1_STATUS status;
    
    SPI1_Initialize;
    
    unsigned int    total;
    total = 0;
    
        do
    {   
            CS0_SetLow();
        total  = SPI1_Exchange16bitBuffer( &myWriteBuffer[total], MY_BUFFER_SIZE - total, &myWriteBuffer[total]);

        // Do something else...
    

    } while( total < MY_BUFFER_SIZE );
    
    CS0_SetHigh();
    
    CS0_SetLow();

    readData = SPI1_Exchange16bit(writeData);

    status = SPI1_StatusGet();
    
    CS0_SetHigh();
    

    
    
    
    
    enum MODE {
        NONE, CHARGE, DISCHARGE, REDISTRIBUTE
    };
    enum MODE mode = NONE;


    bool ERROR, IsCHARGE, IsDISCHARGE;

    LED_All();
    // When using interrupts, you need to set the Global Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalDisable();



    while (1) {
        // Add your application code

        switch (mode) {
            case NONE:
                Charge_SetLow();
                Discharge_SetLow();
                PTCONbits.PTEN = 0;
                

                break;

            case REDISTRIBUTE:
                Charge_SetHigh();
                Discharge_SetHigh();
                break;

            case CHARGE:
                Charge_SetHigh();
                Discharge_SetLow();
                
                PDC1=0;
                IOCON1bits.SWAP = 0;
                PDC1 = 200;
                //PTCONbits.PTEN = 1;
                break;

            case DISCHARGE:
                Discharge_SetHigh();
                Charge_SetLow();
                
                PDC1 = 0;
                IOCON1bits.SWAP = 1;
                PDC1 = 200;
                //PTCONbits.PTEN = 1;
                
                
                break;

            default:

                break;

    




        }

        /*
             Detect the operating mode
         */
        Nop();
        IsCHARGE = PIND_GetValue();
        IsDISCHARGE = PINC_GetValue();
        Nop();
        


        if ((IsCHARGE == 0)&&(IsDISCHARGE == 0)) {
            mode = REDISTRIBUTE;
        } else if ((IsCHARGE == 0)&&(IsDISCHARGE == 1)) {
            mode = CHARGE;
        } else if ((IsCHARGE == 1)&&(IsDISCHARGE == 0)) {
            mode = DISCHARGE;
        } else mode = NONE;
        
        if (ADC_FLAG = 1)
        {
            CS0_SetLow();
            
            Fault_SetLow();
            
            garbage = SPI1BUF;
            
            readData = SPI1_Exchange16bit( writeData);
            
            Fault_SetHigh();



            CS0_SetHigh();
                //CS0_SetLow();
                //SPI2_Exchange16bitBuffer(*ADC_C,2,*HighSideC);
                //*HighSideC = SPI2_Exchange16bit(0b11000000000000);
                //CS0_SetHigh();
            ADC_FLAG = 0;
        }
    



        
        
    }

    return 0;
}

/* Example code for Timer1 ISR*/
void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void)
{
/* Interrupt Service Routine code goes here */
    //Fault_Toggle();
    ADC_FLAG = 1;

    IFS0bits.T1IF = 0; //Clear Timer1 interrupt flag
}

// Called on 16bits finished shifting in OR out of SPI2 buffer
void __attribute__((__interrupt__, auto_psv)) _SPI2Interrupt(void) {
  // Return CS high
  //CS0_SetHigh();
  //CS1_SetHigh();

  // Clear the source of the interrupt
  _SPI2IF = 0;
}

/**
 End of File
 */